package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.dao.Dao;
import com.wadpam.survey.domain.DAnswer;
import net.sf.mardao.core.geo.DLocation;

/**
 * DAO interface with finder methods for DAnswer entities.
 *
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public interface GeneratedDAnswerDao extends Dao<DAnswer, java.lang.Long> {

	/** Column name for primary key attribute is "id" */
	static final String COLUMN_NAME_ID = "id";


	/** Column name for field answer is "answer" */
	static final String COLUMN_NAME_ANSWER = "answer";
	/** Column name for field createdBy is "createdBy" */
	static final String COLUMN_NAME_CREATEDBY = "createdBy";
	/** Column name for field createdDate is "createdDate" */
	static final String COLUMN_NAME_CREATEDDATE = "createdDate";
	/** Column name for field question is "question" */
	static final String COLUMN_NAME_QUESTION = "question";
	/** Column name for field response is "response" */
	static final String COLUMN_NAME_RESPONSE = "response";
	/** Column name for field survey is "survey" */
	static final String COLUMN_NAME_SURVEY = "survey";
	/** Column name for field updatedBy is "updatedBy" */
	static final String COLUMN_NAME_UPDATEDBY = "updatedBy";
	/** Column name for field updatedDate is "updatedDate" */
	static final String COLUMN_NAME_UPDATEDDATE = "updatedDate";
	/** Column name for field version is "version" */
	static final String COLUMN_NAME_VERSION = "version";

	/** The list of attribute names */
	static final List<String> COLUMN_NAMES = Arrays.asList(		COLUMN_NAME_ANSWER,
		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_QUESTION,
		COLUMN_NAME_RESPONSE,
		COLUMN_NAME_SURVEY,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE,
		COLUMN_NAME_VERSION);
	/** The list of Basic attribute names */
	static final List<String> BASIC_NAMES = Arrays.asList(		COLUMN_NAME_ANSWER,
		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of attribute names */
	static final List<String> MANY_TO_ONE_NAMES = Arrays.asList(		COLUMN_NAME_QUESTION,
		COLUMN_NAME_RESPONSE,
		COLUMN_NAME_SURVEY,
		COLUMN_NAME_VERSION);


	// ----------------------- field finders -------------------------------
	/**
	 * query-by method for field answer
	 * @param answer the specified attribute
	 * @return an Iterable of DAnswers for the specified answer
	 */
	Iterable<DAnswer> queryByAnswer(java.lang.String answer);
		
	/**
	 * query-keys-by method for field answer
	 * @param answer the specified attribute
	 * @return an Iterable of DAnswers for the specified answer
	 */
	Iterable<java.lang.Long> queryKeysByAnswer(java.lang.String answer);

	/**
	 * query-page-by method for field answer
	 * @param answer the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified answer
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByAnswer(java.lang.String answer,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DAnswers for the specified createdBy
	 */
	Iterable<DAnswer> queryByCreatedBy(java.lang.String createdBy);
		
	/**
	 * query-keys-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DAnswers for the specified createdBy
	 */
	Iterable<java.lang.Long> queryKeysByCreatedBy(java.lang.String createdBy);

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified createdBy
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DAnswers for the specified createdDate
	 */
	Iterable<DAnswer> queryByCreatedDate(java.util.Date createdDate);
		
	/**
	 * query-keys-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DAnswers for the specified createdDate
	 */
	Iterable<java.lang.Long> queryKeysByCreatedDate(java.util.Date createdDate);

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified createdDate
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DAnswers for the specified updatedBy
	 */
	Iterable<DAnswer> queryByUpdatedBy(java.lang.String updatedBy);
		
	/**
	 * query-keys-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DAnswers for the specified updatedBy
	 */
	Iterable<java.lang.Long> queryKeysByUpdatedBy(java.lang.String updatedBy);

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified updatedBy
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DAnswers for the specified updatedDate
	 */
	Iterable<DAnswer> queryByUpdatedDate(java.util.Date updatedDate);
		
	/**
	 * query-keys-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DAnswers for the specified updatedDate
	 */
	Iterable<java.lang.Long> queryKeysByUpdatedDate(java.util.Date updatedDate);

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified updatedDate
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString);


		  
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	/**
	 * query-by method for many-to-one field question
	 * @param question the id of the related com.wadpam.survey.domain.DQuestion entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	Iterable<DAnswer> queryByQuestion(com.wadpam.survey.domain.DQuestion question);

	/**
	 * query-page-by method for many-to-one field question
	 * @param question the related com.wadpam.survey.domain.DQuestion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByQuestion(com.wadpam.survey.domain.DQuestion question,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field question
	 * @param id the related com.wadpam.survey.domain.DQuestion entity's primary key
	 * @return a Collection of DAnswers belonging to the many-to-one relation
	 */
	List<DAnswer> findByQuestionId(java.lang.Long id);
	
	/**
	 * query-by method for many-to-one field response
	 * @param response the id of the related com.wadpam.survey.domain.DResponse entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	Iterable<DAnswer> queryByResponse(com.wadpam.survey.domain.DResponse response);

	/**
	 * query-page-by method for many-to-one field response
	 * @param response the related com.wadpam.survey.domain.DResponse entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByResponse(com.wadpam.survey.domain.DResponse response,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field response
	 * @param id the related com.wadpam.survey.domain.DResponse entity's primary key
	 * @return a Collection of DAnswers belonging to the many-to-one relation
	 */
	List<DAnswer> findByResponseId(java.lang.Long id);
	
	/**
	 * query-by method for many-to-one field survey
	 * @param survey the id of the related com.wadpam.survey.domain.DSurvey entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	Iterable<DAnswer> queryBySurvey(com.wadpam.survey.domain.DSurvey survey);

	/**
	 * query-page-by method for many-to-one field survey
	 * @param survey the related com.wadpam.survey.domain.DSurvey entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageBySurvey(com.wadpam.survey.domain.DSurvey survey,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field survey
	 * @param id the related com.wadpam.survey.domain.DSurvey entity's primary key
	 * @return a Collection of DAnswers belonging to the many-to-one relation
	 */
	List<DAnswer> findBySurveyId(java.lang.Long id);
	
	/**
	 * query-by method for many-to-one field version
	 * @param version the id of the related com.wadpam.survey.domain.DVersion entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	Iterable<DAnswer> queryByVersion(com.wadpam.survey.domain.DVersion version);

	/**
	 * query-page-by method for many-to-one field version
	 * @param version the related com.wadpam.survey.domain.DVersion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	CursorPage<DAnswer, java.lang.Long> queryPageByVersion(com.wadpam.survey.domain.DVersion version,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field version
	 * @param id the related com.wadpam.survey.domain.DVersion entity's primary key
	 * @return a Collection of DAnswers belonging to the many-to-one relation
	 */
	List<DAnswer> findByVersionId(java.lang.Long id);
	
	
	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	
	/**
	 * find-by method for unique fields
	 * @param question the specified question
	 * @param response the specified response
	 * @return the unique DAnswer for the specified fields
	 */
	DAnswer findByQuestionResponse(com.wadpam.survey.domain.DQuestion question, com.wadpam.survey.domain.DResponse response);

	
	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	DAnswer persist(		java.lang.Long id, 
		java.lang.String answer, 
		com.wadpam.survey.domain.DQuestion question, 
		com.wadpam.survey.domain.DResponse response, 
		com.wadpam.survey.domain.DSurvey survey, 
		com.wadpam.survey.domain.DVersion version);	

}
