package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.Filter;
import net.sf.mardao.core.dao.DaoImpl;
import net.sf.mardao.core.dao.TypeDaoImpl;
import net.sf.mardao.core.geo.DLocation;
import com.wadpam.survey.domain.DAnswer;
import com.wadpam.survey.domain.DQuestion;
import com.wadpam.survey.domain.DResponse;
import com.wadpam.survey.domain.DSurvey;
import com.wadpam.survey.domain.DVersion;

/**
 * The DAnswer domain-object specific finders and methods go in this POJO.
 * 
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public class GeneratedDAnswerDaoImpl extends TypeDaoImpl<DAnswer, java.lang.Long> 
	implements GeneratedDAnswerDao {

    /** DAO for Many-To-One relation question */
    private GeneratedDQuestionDaoImpl questionDao;
    /** Setter for Many-To-One question DAO */
    public void setQuestionDao(GeneratedDQuestionDaoImpl dao) {
        questionDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_QUESTION, dao);
    }
    /** Getter for Many-To-One question DAO */
    protected GeneratedDQuestionDaoImpl getQuestionDao() {
        return questionDao;
    }
    /** DAO for Many-To-One relation response */
    private GeneratedDResponseDaoImpl responseDao;
    /** Setter for Many-To-One response DAO */
    public void setResponseDao(GeneratedDResponseDaoImpl dao) {
        responseDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_RESPONSE, dao);
    }
    /** Getter for Many-To-One response DAO */
    protected GeneratedDResponseDaoImpl getResponseDao() {
        return responseDao;
    }
    /** DAO for Many-To-One relation survey */
    private GeneratedDSurveyDaoImpl surveyDao;
    /** Setter for Many-To-One survey DAO */
    public void setSurveyDao(GeneratedDSurveyDaoImpl dao) {
        surveyDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_SURVEY, dao);
    }
    /** Getter for Many-To-One survey DAO */
    protected GeneratedDSurveyDaoImpl getSurveyDao() {
        return surveyDao;
    }
    /** DAO for Many-To-One relation version */
    private GeneratedDVersionDaoImpl versionDao;
    /** Setter for Many-To-One version DAO */
    public void setVersionDao(GeneratedDVersionDaoImpl dao) {
        versionDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_VERSION, dao);
    }
    /** Getter for Many-To-One version DAO */
    protected GeneratedDVersionDaoImpl getVersionDao() {
        return versionDao;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getBasicColumnNames() {
        return BASIC_NAMES;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getManyToOneColumnNames() {
        return MANY_TO_ONE_NAMES;
    }

    private final Map<String, DaoImpl> MANY_TO_ONE_DAOS = new TreeMap<String, DaoImpl>();

    /** Default constructor */
   public GeneratedDAnswerDaoImpl() {
      super(DAnswer.class, java.lang.Long.class);
   }

   // ------ BEGIN DaoImpl overrides -----------------------------
   
   public String getPrimaryKeyColumnName() {
   		return COLUMN_NAME_ID;
   }
   
   public List<String> getColumnNames() {
        return COLUMN_NAMES;
   }

   @Override
   protected DaoImpl getManyToOneDao(String columnName) {
       return MANY_TO_ONE_DAOS.get(columnName);
   }

    @Override
    protected Object getDomainProperty(DAnswer domain, String name) {
        Object value;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            value = domain.getId();
        }
        // fields
        else if (COLUMN_NAME_ANSWER.equals(name)) {
            value = domain.getAnswer();
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            value = domain.getCreatedBy();
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            value = domain.getCreatedDate();
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            value = domain.getUpdatedBy();
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            value = domain.getUpdatedDate();
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            final com.wadpam.survey.domain.DQuestion foreign = domain.getQuestion();
            final Object foreignKey = questionDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        else if (COLUMN_NAME_RESPONSE.equals(name)) {
            final com.wadpam.survey.domain.DResponse foreign = domain.getResponse();
            final Object foreignKey = responseDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            final com.wadpam.survey.domain.DSurvey foreign = domain.getSurvey();
            final Object foreignKey = surveyDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            final com.wadpam.survey.domain.DVersion foreign = domain.getVersion();
            final Object foreignKey = versionDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        // many-to-manys
        else {
            value = super.getDomainProperty(domain, name);
        }

        return value;
    }

    /**
     * Returns the class of the domain property for specified column
     * @param name
     * @return the class of the domain property
     */
    public Class getColumnClass(String name) {
        Class clazz;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            clazz = java.lang.Long.class;
        }
        // fields
        else if (COLUMN_NAME_ANSWER.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            clazz = com.wadpam.survey.domain.DQuestion.class;
        }
        else if (COLUMN_NAME_RESPONSE.equals(name)) {
            clazz = com.wadpam.survey.domain.DResponse.class;
        }
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = com.wadpam.survey.domain.DSurvey.class;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = com.wadpam.survey.domain.DVersion.class;
        }
        // many-to-manys
        else {
            throw new IllegalArgumentException("No such column " + name);
        }

        return clazz;
    }
      
    @Override
    protected void setDomainProperty(final DAnswer domain, final String name, final Object value) {
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            domain.setId((java.lang.Long) value);
        }
        // fields
        else if (COLUMN_NAME_ANSWER.equals(name)) {
            domain.setAnswer((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            domain.setCreatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            domain.setCreatedDate((java.util.Date) value);
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            domain.setUpdatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            domain.setUpdatedDate((java.util.Date) value);
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            DQuestion foreign = null;
            if (null != value) {
                try {
                    foreign = questionDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setQuestion(foreign);
        }
        else if (COLUMN_NAME_RESPONSE.equals(name)) {
            DResponse foreign = null;
            if (null != value) {
                try {
                    foreign = responseDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setResponse(foreign);
        }
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            DSurvey foreign = null;
            if (null != value) {
                try {
                    foreign = surveyDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setSurvey(foreign);
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            DVersion foreign = null;
            if (null != value) {
                try {
                    foreign = versionDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setVersion(foreign);
        }
        // many-to-manys
        else {
            super.setDomainProperty(domain, name, value);
        }
    }

    @Override
    protected void setDomainStringProperty(final DAnswer domain, final String name, final Map<String, String> properties) {
        final String value = properties.get(name);
        Class clazz = getColumnClass(name);
        // many-to-ones
        if (COLUMN_NAME_QUESTION.equals(name)) {
            clazz = java.lang.Long.class;
        }
        if (COLUMN_NAME_RESPONSE.equals(name)) {
            clazz = java.lang.Long.class;
        }
        if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = java.lang.Long.class;
        }
        if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = java.lang.Long.class;
        }
        setDomainProperty(domain, name, parseProperty(value, clazz));
    }

    /**
     * Overrides to substitute Entity properties with foreign keys
     */
    @Override
    protected void setCoreProperty(Object core, String name, Object value) {
        if (null == core || null == name) {
            return;
        }
        else if (null == value) {
            // do nothing in particular, will call super at end
        }
        super.setCoreProperty(core, name, value);
    }

   // ------ END DaoImpl overrides -----------------------------

        // DAnswer has no parent

        /**
         * @return the simple key for specified DAnswer domain object
         */
        public Long getSimpleKey(DAnswer domain) {
            if (null == domain) {
                return null;
            }
            return domain.getId();
        }

        /**
         * @return the simple key for specified DAnswer domain object
         */
        public void setSimpleKey(DAnswer domain, Long id) {
            domain.setId(id);
        }

        public String getCreatedByColumnName() {
            return COLUMN_NAME_CREATEDBY;
        }

        public String getCreatedBy(DAnswer domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedBy();
        }

        public void _setCreatedBy(DAnswer domain, String creator) {
            domain.setCreatedBy(creator);
        }

        public String getUpdatedByColumnName() {
            return COLUMN_NAME_UPDATEDBY;
        }

        public String getUpdatedBy(DAnswer domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedBy();
        }

        public void _setUpdatedBy(DAnswer domain, String updator) {
            domain.setUpdatedBy(updator);
        }

        public String getCreatedDateColumnName() {
            return COLUMN_NAME_CREATEDDATE;
        }

        public Date getCreatedDate(DAnswer domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedDate();
        }

        public void _setCreatedDate(DAnswer domain, Date date) {
            domain.setCreatedDate(date);
        }

        public String getUpdatedDateColumnName() {
            return COLUMN_NAME_UPDATEDDATE;
        }

        public Date getUpdatedDate(DAnswer domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedDate();
        }

        public void _setUpdatedDate(DAnswer domain, Date date) {
            domain.setUpdatedDate(date);
        }

	// ----------------------- field finders -------------------------------
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAnswer> queryByAnswer(java.lang.String answer) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ANSWER, answer);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field answer
	 * @param answer the specified attribute
	 * @return an Iterable of keys to the DAnswers with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByAnswer(java.lang.String answer) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ANSWER, answer);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field answer
	 * @param answer the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified answer
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByAnswer(java.lang.String answer,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ANSWER, answer);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAnswer> queryByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of keys to the DAnswers with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified createdBy
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAnswer> queryByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of keys to the DAnswers with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified createdDate
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAnswer> queryByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of keys to the DAnswers with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified updatedBy
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DAnswer> queryByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of keys to the DAnswers with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DAnswers for the specified updatedDate
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	/**
	 * query-by method for many-to-one field question
	 * @param question the id of the related com.wadpam.survey.domain.DQuestion entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	public final Iterable<DAnswer> queryByQuestion(com.wadpam.survey.domain.DQuestion question) {
            final Object foreignKey = questionDao.getPrimaryKey(question);
            final Filter filter = createEqualsFilter(COLUMN_NAME_QUESTION, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field question
	 * @param question the related com.wadpam.survey.domain.DQuestion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByQuestion(com.wadpam.survey.domain.DQuestion question,
                int pageSize, String cursorString) {
            final Object foreignKey = questionDao.getPrimaryKey(question);
            final Filter filter = createEqualsFilter(COLUMN_NAME_QUESTION, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field question
	 * @param id the related com.wadpam.survey.domain.DQuestion entity's primary key
	 * @return a List of DAnswers belonging to the many-to-one relation
	 */
	public final List<DAnswer> findByQuestionId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_QUESTION, com.wadpam.survey.domain.DQuestion.class, id);
	}	
	
	/**
	 * query-by method for many-to-one field response
	 * @param response the id of the related com.wadpam.survey.domain.DResponse entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	public final Iterable<DAnswer> queryByResponse(com.wadpam.survey.domain.DResponse response) {
            final Object foreignKey = responseDao.getPrimaryKey(response);
            final Filter filter = createEqualsFilter(COLUMN_NAME_RESPONSE, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field response
	 * @param response the related com.wadpam.survey.domain.DResponse entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByResponse(com.wadpam.survey.domain.DResponse response,
                int pageSize, String cursorString) {
            final Object foreignKey = responseDao.getPrimaryKey(response);
            final Filter filter = createEqualsFilter(COLUMN_NAME_RESPONSE, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field response
	 * @param id the related com.wadpam.survey.domain.DResponse entity's primary key
	 * @return a List of DAnswers belonging to the many-to-one relation
	 */
	public final List<DAnswer> findByResponseId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_RESPONSE, com.wadpam.survey.domain.DResponse.class, id);
	}	
	
	/**
	 * query-by method for many-to-one field survey
	 * @param survey the id of the related com.wadpam.survey.domain.DSurvey entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	public final Iterable<DAnswer> queryBySurvey(com.wadpam.survey.domain.DSurvey survey) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field survey
	 * @param survey the related com.wadpam.survey.domain.DSurvey entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageBySurvey(com.wadpam.survey.domain.DSurvey survey,
                int pageSize, String cursorString) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field survey
	 * @param id the related com.wadpam.survey.domain.DSurvey entity's primary key
	 * @return a List of DAnswers belonging to the many-to-one relation
	 */
	public final List<DAnswer> findBySurveyId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_SURVEY, com.wadpam.survey.domain.DSurvey.class, id);
	}	
	
	/**
	 * query-by method for many-to-one field version
	 * @param version the id of the related com.wadpam.survey.domain.DVersion entity
	 * @return an Iterable of DAnswers belonging to the many-to-one relation
	 */
	public final Iterable<DAnswer> queryByVersion(com.wadpam.survey.domain.DVersion version) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field version
	 * @param version the related com.wadpam.survey.domain.DVersion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DAnswers belonging to the many-to-one relation
	 */
	public final CursorPage<DAnswer, java.lang.Long> queryPageByVersion(com.wadpam.survey.domain.DVersion version,
                int pageSize, String cursorString) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field version
	 * @param id the related com.wadpam.survey.domain.DVersion entity's primary key
	 * @return a List of DAnswers belonging to the many-to-one relation
	 */
	public final List<DAnswer> findByVersionId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_VERSION, com.wadpam.survey.domain.DVersion.class, id);
	}	
	

	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	/**
	 * find-by method for unique attributes
	 * @param question the specified question
	 * @param response the specified response
	 * @return the unique DAnswer for the specified fields
	 */
	public final DAnswer findByQuestionResponse(com.wadpam.survey.domain.DQuestion question, com.wadpam.survey.domain.DResponse response) {
		final Filter[] filters = new Filter[2];
                int i = 0;
                filters[i++] = createEqualsFilter(COLUMN_NAME_QUESTION, question);
                filters[i++] = createEqualsFilter(COLUMN_NAME_RESPONSE, response);
		return findUniqueBy(filters);
	}

	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	public DAnswer persist(		java.lang.Long id, 
		java.lang.String answer, 
		com.wadpam.survey.domain.DQuestion question, 
		com.wadpam.survey.domain.DResponse response, 
		com.wadpam.survey.domain.DSurvey survey, 
		com.wadpam.survey.domain.DVersion version) {

            DAnswer domain = null;
            // if primaryKey specified, use it
            if (null != id) {
                    domain = findByPrimaryKey(id);
            }
		
            // use find-by unique column set
            if (null == domain) {
                domain = findByQuestionResponse(
                    question,                     response);
            }
            // create new?
            if (null == domain) {
                    domain = new DAnswer();
                    // generate Id?
                    if (null != id) {
                            domain.setId(id);
                    }
                    // fields
                    domain.setAnswer(answer);
                    // one-to-ones
                    // many-to-ones
                    domain.setQuestion(question);
                    domain.setResponse(response);
                    domain.setSurvey(survey);
                    domain.setVersion(version);
			
                    persist(domain);
            }
            return domain;
	}



}
