package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.Filter;
import net.sf.mardao.core.dao.DaoImpl;
import net.sf.mardao.core.dao.TypeDaoImpl;
import net.sf.mardao.core.geo.DLocation;
import com.wadpam.survey.domain.DQuestion;
import com.wadpam.survey.domain.DSurvey;
import com.wadpam.survey.domain.DVersion;

/**
 * The DQuestion domain-object specific finders and methods go in this POJO.
 * 
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public class GeneratedDQuestionDaoImpl extends TypeDaoImpl<DQuestion, java.lang.Long> 
	implements GeneratedDQuestionDao {

    /** DAO for Many-To-One relation survey */
    private GeneratedDSurveyDaoImpl surveyDao;
    /** Setter for Many-To-One survey DAO */
    public void setSurveyDao(GeneratedDSurveyDaoImpl dao) {
        surveyDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_SURVEY, dao);
    }
    /** Getter for Many-To-One survey DAO */
    protected GeneratedDSurveyDaoImpl getSurveyDao() {
        return surveyDao;
    }
    /** DAO for Many-To-One relation version */
    private GeneratedDVersionDaoImpl versionDao;
    /** Setter for Many-To-One version DAO */
    public void setVersionDao(GeneratedDVersionDaoImpl dao) {
        versionDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_VERSION, dao);
    }
    /** Getter for Many-To-One version DAO */
    protected GeneratedDVersionDaoImpl getVersionDao() {
        return versionDao;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getBasicColumnNames() {
        return BASIC_NAMES;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getManyToOneColumnNames() {
        return MANY_TO_ONE_NAMES;
    }

    private final Map<String, DaoImpl> MANY_TO_ONE_DAOS = new TreeMap<String, DaoImpl>();

    /** Default constructor */
   public GeneratedDQuestionDaoImpl() {
      super(DQuestion.class, java.lang.Long.class);
   }

   // ------ BEGIN DaoImpl overrides -----------------------------
   
   public String getPrimaryKeyColumnName() {
   		return COLUMN_NAME_ID;
   }
   
   public List<String> getColumnNames() {
        return COLUMN_NAMES;
   }

   @Override
   protected DaoImpl getManyToOneDao(String columnName) {
       return MANY_TO_ONE_DAOS.get(columnName);
   }

    @Override
    protected Object getDomainProperty(DQuestion domain, String name) {
        Object value;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            value = domain.getId();
        }
        // fields
        else if (COLUMN_NAME_APPARG0.equals(name)) {
            value = domain.getAppArg0();
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            value = domain.getCreatedBy();
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            value = domain.getCreatedDate();
        }
        else if (COLUMN_NAME_ORDERING.equals(name)) {
            value = domain.getOrdering();
        }
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            value = domain.getQuestion();
        }
        else if (COLUMN_NAME_REQUIRED.equals(name)) {
            value = domain.getRequired();
        }
        else if (COLUMN_NAME_TYPE.equals(name)) {
            value = domain.getType();
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            value = domain.getUpdatedBy();
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            value = domain.getUpdatedDate();
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            final com.wadpam.survey.domain.DSurvey foreign = domain.getSurvey();
            final Object foreignKey = surveyDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            final com.wadpam.survey.domain.DVersion foreign = domain.getVersion();
            final Object foreignKey = versionDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        // many-to-manys
        else {
            value = super.getDomainProperty(domain, name);
        }

        return value;
    }

    /**
     * Returns the class of the domain property for specified column
     * @param name
     * @return the class of the domain property
     */
    public Class getColumnClass(String name) {
        Class clazz;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            clazz = java.lang.Long.class;
        }
        // fields
        else if (COLUMN_NAME_APPARG0.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        else if (COLUMN_NAME_ORDERING.equals(name)) {
            clazz = java.lang.Long.class;
        }
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_REQUIRED.equals(name)) {
            clazz = java.lang.Long.class;
        }
        else if (COLUMN_NAME_TYPE.equals(name)) {
            clazz = java.lang.Long.class;
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = com.wadpam.survey.domain.DSurvey.class;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = com.wadpam.survey.domain.DVersion.class;
        }
        // many-to-manys
        else {
            throw new IllegalArgumentException("No such column " + name);
        }

        return clazz;
    }
      
    @Override
    protected void setDomainProperty(final DQuestion domain, final String name, final Object value) {
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            domain.setId((java.lang.Long) value);
        }
        // fields
        else if (COLUMN_NAME_APPARG0.equals(name)) {
            domain.setAppArg0((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            domain.setCreatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            domain.setCreatedDate((java.util.Date) value);
        }
        else if (COLUMN_NAME_ORDERING.equals(name)) {
            domain.setOrdering((java.lang.Long) value);
        }
        else if (COLUMN_NAME_QUESTION.equals(name)) {
            domain.setQuestion((java.lang.String) value);
        }
        else if (COLUMN_NAME_REQUIRED.equals(name)) {
            domain.setRequired((java.lang.Long) value);
        }
        else if (COLUMN_NAME_TYPE.equals(name)) {
            domain.setType((java.lang.Long) value);
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            domain.setUpdatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            domain.setUpdatedDate((java.util.Date) value);
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            DSurvey foreign = null;
            if (null != value) {
                try {
                    foreign = surveyDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setSurvey(foreign);
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            DVersion foreign = null;
            if (null != value) {
                try {
                    foreign = versionDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setVersion(foreign);
        }
        // many-to-manys
        else {
            super.setDomainProperty(domain, name, value);
        }
    }

    @Override
    protected void setDomainStringProperty(final DQuestion domain, final String name, final Map<String, String> properties) {
        final String value = properties.get(name);
        Class clazz = getColumnClass(name);
        // many-to-ones
        if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = java.lang.Long.class;
        }
        if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = java.lang.Long.class;
        }
        setDomainProperty(domain, name, parseProperty(value, clazz));
    }

    /**
     * Overrides to substitute Entity properties with foreign keys
     */
    @Override
    protected void setCoreProperty(Object core, String name, Object value) {
        if (null == core || null == name) {
            return;
        }
        else if (null == value) {
            // do nothing in particular, will call super at end
        }
        super.setCoreProperty(core, name, value);
    }

   // ------ END DaoImpl overrides -----------------------------

        // DQuestion has no parent

        /**
         * @return the simple key for specified DQuestion domain object
         */
        public Long getSimpleKey(DQuestion domain) {
            if (null == domain) {
                return null;
            }
            return domain.getId();
        }

        /**
         * @return the simple key for specified DQuestion domain object
         */
        public void setSimpleKey(DQuestion domain, Long id) {
            domain.setId(id);
        }

        public String getCreatedByColumnName() {
            return COLUMN_NAME_CREATEDBY;
        }

        public String getCreatedBy(DQuestion domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedBy();
        }

        public void _setCreatedBy(DQuestion domain, String creator) {
            domain.setCreatedBy(creator);
        }

        public String getUpdatedByColumnName() {
            return COLUMN_NAME_UPDATEDBY;
        }

        public String getUpdatedBy(DQuestion domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedBy();
        }

        public void _setUpdatedBy(DQuestion domain, String updator) {
            domain.setUpdatedBy(updator);
        }

        public String getCreatedDateColumnName() {
            return COLUMN_NAME_CREATEDDATE;
        }

        public Date getCreatedDate(DQuestion domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedDate();
        }

        public void _setCreatedDate(DQuestion domain, Date date) {
            domain.setCreatedDate(date);
        }

        public String getUpdatedDateColumnName() {
            return COLUMN_NAME_UPDATEDDATE;
        }

        public Date getUpdatedDate(DQuestion domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedDate();
        }

        public void _setUpdatedDate(DQuestion domain, Date date) {
            domain.setUpdatedDate(date);
        }

	// ----------------------- field finders -------------------------------
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByAppArg0(java.lang.String appArg0) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_APPARG0, appArg0);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field appArg0
	 * @param appArg0 the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByAppArg0(java.lang.String appArg0) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_APPARG0, appArg0);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field appArg0
	 * @param appArg0 the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified appArg0
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByAppArg0(java.lang.String appArg0,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_APPARG0, appArg0);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified createdBy
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified createdDate
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByOrdering(java.lang.Long ordering) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ORDERING, ordering);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field ordering
	 * @param ordering the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByOrdering(java.lang.Long ordering) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ORDERING, ordering);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field ordering
	 * @param ordering the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified ordering
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByOrdering(java.lang.Long ordering,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_ORDERING, ordering);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByQuestion(java.lang.String question) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_QUESTION, question);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field question
	 * @param question the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByQuestion(java.lang.String question) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_QUESTION, question);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field question
	 * @param question the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified question
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByQuestion(java.lang.String question,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_QUESTION, question);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByRequired(java.lang.Long required) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_REQUIRED, required);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field required
	 * @param required the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByRequired(java.lang.Long required) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_REQUIRED, required);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field required
	 * @param required the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified required
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByRequired(java.lang.Long required,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_REQUIRED, required);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByType(java.lang.Long type) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_TYPE, type);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field type
	 * @param type the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByType(java.lang.Long type) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_TYPE, type);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field type
	 * @param type the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified type
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByType(java.lang.Long type,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_TYPE, type);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified updatedBy
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DQuestion> queryByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of keys to the DQuestions with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DQuestions for the specified updatedDate
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	/**
	 * query-by method for many-to-one field survey
	 * @param survey the id of the related com.wadpam.survey.domain.DSurvey entity
	 * @return an Iterable of DQuestions belonging to the many-to-one relation
	 */
	public final Iterable<DQuestion> queryBySurvey(com.wadpam.survey.domain.DSurvey survey) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field survey
	 * @param survey the related com.wadpam.survey.domain.DSurvey entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DQuestions belonging to the many-to-one relation
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageBySurvey(com.wadpam.survey.domain.DSurvey survey,
                int pageSize, String cursorString) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field survey
	 * @param id the related com.wadpam.survey.domain.DSurvey entity's primary key
	 * @return a List of DQuestions belonging to the many-to-one relation
	 */
	public final List<DQuestion> findBySurveyId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_SURVEY, com.wadpam.survey.domain.DSurvey.class, id);
	}	
	
	/**
	 * query-by method for many-to-one field version
	 * @param version the id of the related com.wadpam.survey.domain.DVersion entity
	 * @return an Iterable of DQuestions belonging to the many-to-one relation
	 */
	public final Iterable<DQuestion> queryByVersion(com.wadpam.survey.domain.DVersion version) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field version
	 * @param version the related com.wadpam.survey.domain.DVersion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DQuestions belonging to the many-to-one relation
	 */
	public final CursorPage<DQuestion, java.lang.Long> queryPageByVersion(com.wadpam.survey.domain.DVersion version,
                int pageSize, String cursorString) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field version
	 * @param id the related com.wadpam.survey.domain.DVersion entity's primary key
	 * @return a List of DQuestions belonging to the many-to-one relation
	 */
	public final List<DQuestion> findByVersionId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_VERSION, com.wadpam.survey.domain.DVersion.class, id);
	}	
	

	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------

	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	public DQuestion persist(		java.lang.Long id, 
		java.lang.String appArg0, 
		java.lang.Long ordering, 
		java.lang.String question, 
		java.lang.Long required, 
		java.lang.Long type, 
		com.wadpam.survey.domain.DSurvey survey, 
		com.wadpam.survey.domain.DVersion version) {

            DQuestion domain = null;
            // if primaryKey specified, use it
            if (null != id) {
                    domain = findByPrimaryKey(id);
            }
		
            // create new?
            if (null == domain) {
                    domain = new DQuestion();
                    // generate Id?
                    if (null != id) {
                            domain.setId(id);
                    }
                    // fields
                    domain.setAppArg0(appArg0);
                    domain.setOrdering(ordering);
                    domain.setQuestion(question);
                    domain.setRequired(required);
                    domain.setType(type);
                    // one-to-ones
                    // many-to-ones
                    domain.setSurvey(survey);
                    domain.setVersion(version);
			
                    persist(domain);
            }
            return domain;
	}



}
