package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.dao.Dao;
import com.wadpam.survey.domain.DResponse;
import net.sf.mardao.core.geo.DLocation;

/**
 * DAO interface with finder methods for DResponse entities.
 *
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public interface GeneratedDResponseDao extends Dao<DResponse, java.lang.Long> {

	/** Column name for primary key attribute is "id" */
	static final String COLUMN_NAME_ID = "id";


	/** Column name for field createdBy is "createdBy" */
	static final String COLUMN_NAME_CREATEDBY = "createdBy";
	/** Column name for field createdDate is "createdDate" */
	static final String COLUMN_NAME_CREATEDDATE = "createdDate";
	/** Column name for field extLocationId is "extLocationId" */
	static final String COLUMN_NAME_EXTLOCATIONID = "extLocationId";
	/** Column name for field extMeetingId is "extMeetingId" */
	static final String COLUMN_NAME_EXTMEETINGID = "extMeetingId";
	/** Column name for field extProductId is "extProductId" */
	static final String COLUMN_NAME_EXTPRODUCTID = "extProductId";
	/** Column name for field extUserId is "extUserId" */
	static final String COLUMN_NAME_EXTUSERID = "extUserId";
	/** Column name for field state is "state" */
	static final String COLUMN_NAME_STATE = "state";
	/** Column name for field survey is "survey" */
	static final String COLUMN_NAME_SURVEY = "survey";
	/** Column name for field updatedBy is "updatedBy" */
	static final String COLUMN_NAME_UPDATEDBY = "updatedBy";
	/** Column name for field updatedDate is "updatedDate" */
	static final String COLUMN_NAME_UPDATEDDATE = "updatedDate";
	/** Column name for field version is "version" */
	static final String COLUMN_NAME_VERSION = "version";

	/** The list of attribute names */
	static final List<String> COLUMN_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_EXTLOCATIONID,
		COLUMN_NAME_EXTMEETINGID,
		COLUMN_NAME_EXTPRODUCTID,
		COLUMN_NAME_EXTUSERID,
		COLUMN_NAME_STATE,
		COLUMN_NAME_SURVEY,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE,
		COLUMN_NAME_VERSION);
	/** The list of Basic attribute names */
	static final List<String> BASIC_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_EXTLOCATIONID,
		COLUMN_NAME_EXTMEETINGID,
		COLUMN_NAME_EXTPRODUCTID,
		COLUMN_NAME_EXTUSERID,
		COLUMN_NAME_STATE,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of attribute names */
	static final List<String> MANY_TO_ONE_NAMES = Arrays.asList(		COLUMN_NAME_SURVEY,
		COLUMN_NAME_VERSION);


	// ----------------------- field finders -------------------------------
	/**
	 * query-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DResponses for the specified createdBy
	 */
	Iterable<DResponse> queryByCreatedBy(java.lang.String createdBy);
		
	/**
	 * query-keys-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of DResponses for the specified createdBy
	 */
	Iterable<java.lang.Long> queryKeysByCreatedBy(java.lang.String createdBy);

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified createdBy
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DResponses for the specified createdDate
	 */
	Iterable<DResponse> queryByCreatedDate(java.util.Date createdDate);
		
	/**
	 * query-keys-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of DResponses for the specified createdDate
	 */
	Iterable<java.lang.Long> queryKeysByCreatedDate(java.util.Date createdDate);

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified createdDate
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString);


	/**
	 * query-by method for field extLocationId
	 * @param extLocationId the specified attribute
	 * @return an Iterable of DResponses for the specified extLocationId
	 */
	Iterable<DResponse> queryByExtLocationId(java.lang.String extLocationId);
		
	/**
	 * query-keys-by method for field extLocationId
	 * @param extLocationId the specified attribute
	 * @return an Iterable of DResponses for the specified extLocationId
	 */
	Iterable<java.lang.Long> queryKeysByExtLocationId(java.lang.String extLocationId);

	/**
	 * query-page-by method for field extLocationId
	 * @param extLocationId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extLocationId
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByExtLocationId(java.lang.String extLocationId,
            int pageSize, String cursorString);


	/**
	 * query-by method for field extMeetingId
	 * @param extMeetingId the specified attribute
	 * @return an Iterable of DResponses for the specified extMeetingId
	 */
	Iterable<DResponse> queryByExtMeetingId(java.lang.String extMeetingId);
		
	/**
	 * query-keys-by method for field extMeetingId
	 * @param extMeetingId the specified attribute
	 * @return an Iterable of DResponses for the specified extMeetingId
	 */
	Iterable<java.lang.Long> queryKeysByExtMeetingId(java.lang.String extMeetingId);

	/**
	 * query-page-by method for field extMeetingId
	 * @param extMeetingId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extMeetingId
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByExtMeetingId(java.lang.String extMeetingId,
            int pageSize, String cursorString);


	/**
	 * query-by method for field extProductId
	 * @param extProductId the specified attribute
	 * @return an Iterable of DResponses for the specified extProductId
	 */
	Iterable<DResponse> queryByExtProductId(java.lang.String extProductId);
		
	/**
	 * query-keys-by method for field extProductId
	 * @param extProductId the specified attribute
	 * @return an Iterable of DResponses for the specified extProductId
	 */
	Iterable<java.lang.Long> queryKeysByExtProductId(java.lang.String extProductId);

	/**
	 * query-page-by method for field extProductId
	 * @param extProductId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extProductId
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByExtProductId(java.lang.String extProductId,
            int pageSize, String cursorString);


	/**
	 * query-by method for field extUserId
	 * @param extUserId the specified attribute
	 * @return an Iterable of DResponses for the specified extUserId
	 */
	Iterable<DResponse> queryByExtUserId(java.lang.String extUserId);
		
	/**
	 * query-keys-by method for field extUserId
	 * @param extUserId the specified attribute
	 * @return an Iterable of DResponses for the specified extUserId
	 */
	Iterable<java.lang.Long> queryKeysByExtUserId(java.lang.String extUserId);

	/**
	 * query-page-by method for field extUserId
	 * @param extUserId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extUserId
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByExtUserId(java.lang.String extUserId,
            int pageSize, String cursorString);


	/**
	 * query-by method for field state
	 * @param state the specified attribute
	 * @return an Iterable of DResponses for the specified state
	 */
	Iterable<DResponse> queryByState(java.lang.Long state);
		
	/**
	 * query-keys-by method for field state
	 * @param state the specified attribute
	 * @return an Iterable of DResponses for the specified state
	 */
	Iterable<java.lang.Long> queryKeysByState(java.lang.Long state);

	/**
	 * query-page-by method for field state
	 * @param state the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified state
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByState(java.lang.Long state,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DResponses for the specified updatedBy
	 */
	Iterable<DResponse> queryByUpdatedBy(java.lang.String updatedBy);
		
	/**
	 * query-keys-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of DResponses for the specified updatedBy
	 */
	Iterable<java.lang.Long> queryKeysByUpdatedBy(java.lang.String updatedBy);

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified updatedBy
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DResponses for the specified updatedDate
	 */
	Iterable<DResponse> queryByUpdatedDate(java.util.Date updatedDate);
		
	/**
	 * query-keys-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of DResponses for the specified updatedDate
	 */
	Iterable<java.lang.Long> queryKeysByUpdatedDate(java.util.Date updatedDate);

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified updatedDate
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString);


		  
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	/**
	 * query-by method for many-to-one field survey
	 * @param survey the id of the related com.wadpam.survey.domain.DSurvey entity
	 * @return an Iterable of DResponses belonging to the many-to-one relation
	 */
	Iterable<DResponse> queryBySurvey(com.wadpam.survey.domain.DSurvey survey);

	/**
	 * query-page-by method for many-to-one field survey
	 * @param survey the related com.wadpam.survey.domain.DSurvey entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DResponses belonging to the many-to-one relation
	 */
	CursorPage<DResponse, java.lang.Long> queryPageBySurvey(com.wadpam.survey.domain.DSurvey survey,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field survey
	 * @param id the related com.wadpam.survey.domain.DSurvey entity's primary key
	 * @return a Collection of DResponses belonging to the many-to-one relation
	 */
	List<DResponse> findBySurveyId(java.lang.Long id);
	
	/**
	 * query-by method for many-to-one field version
	 * @param version the id of the related com.wadpam.survey.domain.DVersion entity
	 * @return an Iterable of DResponses belonging to the many-to-one relation
	 */
	Iterable<DResponse> queryByVersion(com.wadpam.survey.domain.DVersion version);

	/**
	 * query-page-by method for many-to-one field version
	 * @param version the related com.wadpam.survey.domain.DVersion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DResponses belonging to the many-to-one relation
	 */
	CursorPage<DResponse, java.lang.Long> queryPageByVersion(com.wadpam.survey.domain.DVersion version,
            int pageSize, String cursorString);

	/**
	 * find-by method for many-to-one field version
	 * @param id the related com.wadpam.survey.domain.DVersion entity's primary key
	 * @return a Collection of DResponses belonging to the many-to-one relation
	 */
	List<DResponse> findByVersionId(java.lang.Long id);
	
	
	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	
	
	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	DResponse persist(		java.lang.Long id, 
		java.lang.String extLocationId, 
		java.lang.String extMeetingId, 
		java.lang.String extProductId, 
		java.lang.String extUserId, 
		java.lang.Long state, 
		com.wadpam.survey.domain.DSurvey survey, 
		com.wadpam.survey.domain.DVersion version);	

}
