package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.TreeMap;
import org.xml.sax.ContentHandler;
import org.xml.sax.SAXException;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.Filter;
import net.sf.mardao.core.dao.DaoImpl;
import net.sf.mardao.core.dao.TypeDaoImpl;
import net.sf.mardao.core.geo.DLocation;
import com.wadpam.survey.domain.DResponse;
import com.wadpam.survey.domain.DSurvey;
import com.wadpam.survey.domain.DVersion;

/**
 * The DResponse domain-object specific finders and methods go in this POJO.
 * 
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public class GeneratedDResponseDaoImpl extends TypeDaoImpl<DResponse, java.lang.Long> 
	implements GeneratedDResponseDao {

    /** DAO for Many-To-One relation survey */
    private GeneratedDSurveyDaoImpl surveyDao;
    /** Setter for Many-To-One survey DAO */
    public void setSurveyDao(GeneratedDSurveyDaoImpl dao) {
        surveyDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_SURVEY, dao);
    }
    /** Getter for Many-To-One survey DAO */
    protected GeneratedDSurveyDaoImpl getSurveyDao() {
        return surveyDao;
    }
    /** DAO for Many-To-One relation version */
    private GeneratedDVersionDaoImpl versionDao;
    /** Setter for Many-To-One version DAO */
    public void setVersionDao(GeneratedDVersionDaoImpl dao) {
        versionDao = dao;
        MANY_TO_ONE_DAOS.put(COLUMN_NAME_VERSION, dao);
    }
    /** Getter for Many-To-One version DAO */
    protected GeneratedDVersionDaoImpl getVersionDao() {
        return versionDao;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getBasicColumnNames() {
        return BASIC_NAMES;
    }

    /** to list the property names for ManyToOne relations */
    @Override
    protected List<String> getManyToOneColumnNames() {
        return MANY_TO_ONE_NAMES;
    }

    private final Map<String, DaoImpl> MANY_TO_ONE_DAOS = new TreeMap<String, DaoImpl>();

    /** Default constructor */
   public GeneratedDResponseDaoImpl() {
      super(DResponse.class, java.lang.Long.class);
   }

   // ------ BEGIN DaoImpl overrides -----------------------------
   
   public String getPrimaryKeyColumnName() {
   		return COLUMN_NAME_ID;
   }
   
   public List<String> getColumnNames() {
        return COLUMN_NAMES;
   }

   @Override
   protected DaoImpl getManyToOneDao(String columnName) {
       return MANY_TO_ONE_DAOS.get(columnName);
   }

    @Override
    protected Object getDomainProperty(DResponse domain, String name) {
        Object value;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            value = domain.getId();
        }
        // fields
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            value = domain.getCreatedBy();
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            value = domain.getCreatedDate();
        }
        else if (COLUMN_NAME_EXTLOCATIONID.equals(name)) {
            value = domain.getExtLocationId();
        }
        else if (COLUMN_NAME_EXTMEETINGID.equals(name)) {
            value = domain.getExtMeetingId();
        }
        else if (COLUMN_NAME_EXTPRODUCTID.equals(name)) {
            value = domain.getExtProductId();
        }
        else if (COLUMN_NAME_EXTUSERID.equals(name)) {
            value = domain.getExtUserId();
        }
        else if (COLUMN_NAME_STATE.equals(name)) {
            value = domain.getState();
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            value = domain.getUpdatedBy();
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            value = domain.getUpdatedDate();
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            final com.wadpam.survey.domain.DSurvey foreign = domain.getSurvey();
            final Object foreignKey = surveyDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            final com.wadpam.survey.domain.DVersion foreign = domain.getVersion();
            final Object foreignKey = versionDao.getPrimaryKey(foreign);
            value = foreignKey;
        }
        // many-to-manys
        else {
            value = super.getDomainProperty(domain, name);
        }

        return value;
    }

    /**
     * Returns the class of the domain property for specified column
     * @param name
     * @return the class of the domain property
     */
    public Class getColumnClass(String name) {
        Class clazz;
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            clazz = java.lang.Long.class;
        }
        // fields
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        else if (COLUMN_NAME_EXTLOCATIONID.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_EXTMEETINGID.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_EXTPRODUCTID.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_EXTUSERID.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_STATE.equals(name)) {
            clazz = java.lang.Long.class;
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            clazz = java.lang.String.class;
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            clazz = java.util.Date.class;
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = com.wadpam.survey.domain.DSurvey.class;
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = com.wadpam.survey.domain.DVersion.class;
        }
        // many-to-manys
        else {
            throw new IllegalArgumentException("No such column " + name);
        }

        return clazz;
    }
      
    @Override
    protected void setDomainProperty(final DResponse domain, final String name, final Object value) {
        // simple key?
        if (COLUMN_NAME_ID.equals(name)) {
            domain.setId((java.lang.Long) value);
        }
        // fields
        else if (COLUMN_NAME_CREATEDBY.equals(name)) {
            domain.setCreatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_CREATEDDATE.equals(name)) {
            domain.setCreatedDate((java.util.Date) value);
        }
        else if (COLUMN_NAME_EXTLOCATIONID.equals(name)) {
            domain.setExtLocationId((java.lang.String) value);
        }
        else if (COLUMN_NAME_EXTMEETINGID.equals(name)) {
            domain.setExtMeetingId((java.lang.String) value);
        }
        else if (COLUMN_NAME_EXTPRODUCTID.equals(name)) {
            domain.setExtProductId((java.lang.String) value);
        }
        else if (COLUMN_NAME_EXTUSERID.equals(name)) {
            domain.setExtUserId((java.lang.String) value);
        }
        else if (COLUMN_NAME_STATE.equals(name)) {
            domain.setState((java.lang.Long) value);
        }
        else if (COLUMN_NAME_UPDATEDBY.equals(name)) {
            domain.setUpdatedBy((java.lang.String) value);
        }
        else if (COLUMN_NAME_UPDATEDDATE.equals(name)) {
            domain.setUpdatedDate((java.util.Date) value);
        }
        // one-to-ones
        // many-to-ones
        else if (COLUMN_NAME_SURVEY.equals(name)) {
            DSurvey foreign = null;
            if (null != value) {
                try {
                    foreign = surveyDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setSurvey(foreign);
        }
        else if (COLUMN_NAME_VERSION.equals(name)) {
            DVersion foreign = null;
            if (null != value) {
                try {
                    foreign = versionDao.createDomain(value);
                } catch (InstantiationException ex) {
                    LOG.error("Creating foreign domain", ex);
                } catch (IllegalAccessException ex) {
                    LOG.error("Creating foreign domain", ex);
                }
            }
            domain.setVersion(foreign);
        }
        // many-to-manys
        else {
            super.setDomainProperty(domain, name, value);
        }
    }

    @Override
    protected void setDomainStringProperty(final DResponse domain, final String name, final Map<String, String> properties) {
        final String value = properties.get(name);
        Class clazz = getColumnClass(name);
        // many-to-ones
        if (COLUMN_NAME_SURVEY.equals(name)) {
            clazz = java.lang.Long.class;
        }
        if (COLUMN_NAME_VERSION.equals(name)) {
            clazz = java.lang.Long.class;
        }
        setDomainProperty(domain, name, parseProperty(value, clazz));
    }

    /**
     * Overrides to substitute Entity properties with foreign keys
     */
    @Override
    protected void setCoreProperty(Object core, String name, Object value) {
        if (null == core || null == name) {
            return;
        }
        else if (null == value) {
            // do nothing in particular, will call super at end
        }
        super.setCoreProperty(core, name, value);
    }

   // ------ END DaoImpl overrides -----------------------------

        // DResponse has no parent

        /**
         * @return the simple key for specified DResponse domain object
         */
        public Long getSimpleKey(DResponse domain) {
            if (null == domain) {
                return null;
            }
            return domain.getId();
        }

        /**
         * @return the simple key for specified DResponse domain object
         */
        public void setSimpleKey(DResponse domain, Long id) {
            domain.setId(id);
        }

        public String getCreatedByColumnName() {
            return COLUMN_NAME_CREATEDBY;
        }

        public String getCreatedBy(DResponse domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedBy();
        }

        public void _setCreatedBy(DResponse domain, String creator) {
            domain.setCreatedBy(creator);
        }

        public String getUpdatedByColumnName() {
            return COLUMN_NAME_UPDATEDBY;
        }

        public String getUpdatedBy(DResponse domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedBy();
        }

        public void _setUpdatedBy(DResponse domain, String updator) {
            domain.setUpdatedBy(updator);
        }

        public String getCreatedDateColumnName() {
            return COLUMN_NAME_CREATEDDATE;
        }

        public Date getCreatedDate(DResponse domain) {
            if (null == domain) {
                return null;
            }
            return domain.getCreatedDate();
        }

        public void _setCreatedDate(DResponse domain, Date date) {
            domain.setCreatedDate(date);
        }

        public String getUpdatedDateColumnName() {
            return COLUMN_NAME_UPDATEDDATE;
        }

        public Date getUpdatedDate(DResponse domain) {
            if (null == domain) {
                return null;
            }
            return domain.getUpdatedDate();
        }

        public void _setUpdatedDate(DResponse domain, Date date) {
            domain.setUpdatedDate(date);
        }

	// ----------------------- field finders -------------------------------
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedBy(java.lang.String createdBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified createdBy
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDBY, createdBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByCreatedDate(java.util.Date createdDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified createdDate
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_CREATEDDATE, createdDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByExtLocationId(java.lang.String extLocationId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTLOCATIONID, extLocationId);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field extLocationId
	 * @param extLocationId the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByExtLocationId(java.lang.String extLocationId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTLOCATIONID, extLocationId);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field extLocationId
	 * @param extLocationId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extLocationId
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByExtLocationId(java.lang.String extLocationId,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTLOCATIONID, extLocationId);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByExtMeetingId(java.lang.String extMeetingId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTMEETINGID, extMeetingId);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field extMeetingId
	 * @param extMeetingId the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByExtMeetingId(java.lang.String extMeetingId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTMEETINGID, extMeetingId);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field extMeetingId
	 * @param extMeetingId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extMeetingId
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByExtMeetingId(java.lang.String extMeetingId,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTMEETINGID, extMeetingId);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByExtProductId(java.lang.String extProductId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTPRODUCTID, extProductId);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field extProductId
	 * @param extProductId the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByExtProductId(java.lang.String extProductId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTPRODUCTID, extProductId);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field extProductId
	 * @param extProductId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extProductId
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByExtProductId(java.lang.String extProductId,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTPRODUCTID, extProductId);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByExtUserId(java.lang.String extUserId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTUSERID, extUserId);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field extUserId
	 * @param extUserId the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByExtUserId(java.lang.String extUserId) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTUSERID, extUserId);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field extUserId
	 * @param extUserId the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified extUserId
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByExtUserId(java.lang.String extUserId,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_EXTUSERID, extUserId);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByState(java.lang.Long state) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_STATE, state);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field state
	 * @param state the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByState(java.lang.Long state) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_STATE, state);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field state
	 * @param state the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified state
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByState(java.lang.Long state,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_STATE, state);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedBy(java.lang.String updatedBy) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified updatedBy
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDBY, updatedBy);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	/**
         * {@inheritDoc}
	 */
	public final Iterable<DResponse> queryByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}
	
	/**
	 * query-key-by method for attribute field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of keys to the DResponses with the specified attribute
	 */
	public final Iterable<java.lang.Long> queryKeysByUpdatedDate(java.util.Date updatedDate) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryIterableKeys(0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of DResponses for the specified updatedDate
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString) {
            final Filter filter = createEqualsFilter(COLUMN_NAME_UPDATEDDATE, updatedDate);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	 
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	/**
	 * query-by method for many-to-one field survey
	 * @param survey the id of the related com.wadpam.survey.domain.DSurvey entity
	 * @return an Iterable of DResponses belonging to the many-to-one relation
	 */
	public final Iterable<DResponse> queryBySurvey(com.wadpam.survey.domain.DSurvey survey) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field survey
	 * @param survey the related com.wadpam.survey.domain.DSurvey entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DResponses belonging to the many-to-one relation
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageBySurvey(com.wadpam.survey.domain.DSurvey survey,
                int pageSize, String cursorString) {
            final Object foreignKey = surveyDao.getPrimaryKey(survey);
            final Filter filter = createEqualsFilter(COLUMN_NAME_SURVEY, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field survey
	 * @param id the related com.wadpam.survey.domain.DSurvey entity's primary key
	 * @return a List of DResponses belonging to the many-to-one relation
	 */
	public final List<DResponse> findBySurveyId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_SURVEY, com.wadpam.survey.domain.DSurvey.class, id);
	}	
	
	/**
	 * query-by method for many-to-one field version
	 * @param version the id of the related com.wadpam.survey.domain.DVersion entity
	 * @return an Iterable of DResponses belonging to the many-to-one relation
	 */
	public final Iterable<DResponse> queryByVersion(com.wadpam.survey.domain.DVersion version) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryIterable(false, 0, -1, null, null, null, false, null, false, filter);
	}

	/**
	 * query-page-by method for many-to-one field version
	 * @param version the related com.wadpam.survey.domain.DVersion entity
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a CursorPage of DResponses belonging to the many-to-one relation
	 */
	public final CursorPage<DResponse, java.lang.Long> queryPageByVersion(com.wadpam.survey.domain.DVersion version,
                int pageSize, String cursorString) {
            final Object foreignKey = versionDao.getPrimaryKey(version);
            final Filter filter = createEqualsFilter(COLUMN_NAME_VERSION, foreignKey);
            return queryPage(false, pageSize, null, null, null, false, null, false, cursorString, filter);
        }

	/**
	 * find-by method for many-to-one field version
	 * @param id the related com.wadpam.survey.domain.DVersion entity's primary key
	 * @return a List of DResponses belonging to the many-to-one relation
	 */
	public final List<DResponse> findByVersionId(java.lang.Long id) {
            throw new UnsupportedOperationException("Not supported yet.");
//		return findByKey(COLUMN_NAME_VERSION, com.wadpam.survey.domain.DVersion.class, id);
	}	
	

	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------

	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	public DResponse persist(		java.lang.Long id, 
		java.lang.String extLocationId, 
		java.lang.String extMeetingId, 
		java.lang.String extProductId, 
		java.lang.String extUserId, 
		java.lang.Long state, 
		com.wadpam.survey.domain.DSurvey survey, 
		com.wadpam.survey.domain.DVersion version) {

            DResponse domain = null;
            // if primaryKey specified, use it
            if (null != id) {
                    domain = findByPrimaryKey(id);
            }
		
            // create new?
            if (null == domain) {
                    domain = new DResponse();
                    // generate Id?
                    if (null != id) {
                            domain.setId(id);
                    }
                    // fields
                    domain.setExtLocationId(extLocationId);
                    domain.setExtMeetingId(extMeetingId);
                    domain.setExtProductId(extProductId);
                    domain.setExtUserId(extUserId);
                    domain.setState(state);
                    // one-to-ones
                    // many-to-ones
                    domain.setSurvey(survey);
                    domain.setVersion(version);
			
                    persist(domain);
            }
            return domain;
	}



}
