package com.wadpam.survey.dao;

import java.io.Serializable;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import net.sf.mardao.core.CursorPage;
import net.sf.mardao.core.dao.Dao;
import com.wadpam.survey.domain.Di18n;
import net.sf.mardao.core.geo.DLocation;

/**
 * DAO interface with finder methods for Di18n entities.
 *
 * Generated on 2013-03-27T13:58:33.004+0700.
 * @author mardao DAO generator (net.sf.mardao.plugin.ProcessDomainMojo)
 */
public interface GeneratedDi18nDao extends Dao<Di18n, java.lang.String> {

	/** Column name for primary key attribute is "langCode" */
	static final String COLUMN_NAME_LANGCODE = "langCode";

	/** Column name for parent parentKey is "parentKey" */
	static final String COLUMN_NAME_PARENTKEY = "parentKey";


	/** Column name for field createdBy is "createdBy" */
	static final String COLUMN_NAME_CREATEDBY = "createdBy";
	/** Column name for field createdDate is "createdDate" */
	static final String COLUMN_NAME_CREATEDDATE = "createdDate";
	/** Column name for field trans is "trans" */
	static final String COLUMN_NAME_TRANS = "trans";
	/** Column name for field updatedBy is "updatedBy" */
	static final String COLUMN_NAME_UPDATEDBY = "updatedBy";
	/** Column name for field updatedDate is "updatedDate" */
	static final String COLUMN_NAME_UPDATEDDATE = "updatedDate";

	/** The list of attribute names */
	static final List<String> COLUMN_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_TRANS,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of Basic attribute names */
	static final List<String> BASIC_NAMES = Arrays.asList(		COLUMN_NAME_CREATEDBY,
		COLUMN_NAME_CREATEDDATE,
		COLUMN_NAME_TRANS,
		COLUMN_NAME_UPDATEDBY,
		COLUMN_NAME_UPDATEDDATE);
	/** The list of attribute names */
	static final List<String> MANY_TO_ONE_NAMES = Arrays.asList();


	// ----------------------- parent finder -------------------------------
	/**
	 * query-by method for parent field parentKey
	 * @param parentKey the specified attribute
	 * @return an Iterable of Di18ns with the specified parent
	 */
	Iterable<Di18n> queryByParentKey(Object parentKey);
		
	/**
	 * query-keys-by method for parent field parentKey
	 * @param parentKey the specified attribute
	 * @return an Iterable of Di18ns with the specified parent
	 */
	Iterable<java.lang.String> queryKeysByParentKey(Object parentKey);

	/**
	 * query-page-by method for parent field parentKey
	 * @param parentKey the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified parentKey (parent)
	 */
	CursorPage<Di18n, java.lang.String> queryPageByParentKey(java.lang.Object parentKey,
            int pageSize, String cursorString);

	// ----------------------- field finders -------------------------------
	/**
	 * query-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of Di18ns for the specified createdBy
	 */
	Iterable<Di18n> queryByCreatedBy(java.lang.String createdBy);
		
	/**
	 * query-keys-by method for field createdBy
	 * @param createdBy the specified attribute
	 * @return an Iterable of Di18ns for the specified createdBy
	 */
	Iterable<java.lang.String> queryKeysByCreatedBy(java.lang.String createdBy);

	/**
	 * query-page-by method for field createdBy
	 * @param createdBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified createdBy
	 */
	CursorPage<Di18n, java.lang.String> queryPageByCreatedBy(java.lang.String createdBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of Di18ns for the specified createdDate
	 */
	Iterable<Di18n> queryByCreatedDate(java.util.Date createdDate);
		
	/**
	 * query-keys-by method for field createdDate
	 * @param createdDate the specified attribute
	 * @return an Iterable of Di18ns for the specified createdDate
	 */
	Iterable<java.lang.String> queryKeysByCreatedDate(java.util.Date createdDate);

	/**
	 * query-page-by method for field createdDate
	 * @param createdDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified createdDate
	 */
	CursorPage<Di18n, java.lang.String> queryPageByCreatedDate(java.util.Date createdDate,
            int pageSize, String cursorString);


	/**
	 * query-by method for field trans
	 * @param trans the specified attribute
	 * @return an Iterable of Di18ns for the specified trans
	 */
	Iterable<Di18n> queryByTrans(java.lang.String trans);
		
	/**
	 * query-keys-by method for field trans
	 * @param trans the specified attribute
	 * @return an Iterable of Di18ns for the specified trans
	 */
	Iterable<java.lang.String> queryKeysByTrans(java.lang.String trans);

	/**
	 * query-page-by method for field trans
	 * @param trans the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified trans
	 */
	CursorPage<Di18n, java.lang.String> queryPageByTrans(java.lang.String trans,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of Di18ns for the specified updatedBy
	 */
	Iterable<Di18n> queryByUpdatedBy(java.lang.String updatedBy);
		
	/**
	 * query-keys-by method for field updatedBy
	 * @param updatedBy the specified attribute
	 * @return an Iterable of Di18ns for the specified updatedBy
	 */
	Iterable<java.lang.String> queryKeysByUpdatedBy(java.lang.String updatedBy);

	/**
	 * query-page-by method for field updatedBy
	 * @param updatedBy the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified updatedBy
	 */
	CursorPage<Di18n, java.lang.String> queryPageByUpdatedBy(java.lang.String updatedBy,
            int pageSize, String cursorString);


	/**
	 * query-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of Di18ns for the specified updatedDate
	 */
	Iterable<Di18n> queryByUpdatedDate(java.util.Date updatedDate);
		
	/**
	 * query-keys-by method for field updatedDate
	 * @param updatedDate the specified attribute
	 * @return an Iterable of Di18ns for the specified updatedDate
	 */
	Iterable<java.lang.String> queryKeysByUpdatedDate(java.util.Date updatedDate);

	/**
	 * query-page-by method for field updatedDate
	 * @param updatedDate the specified attribute
         * @param pageSize the number of domain entities in the page
         * @param cursorString non-null if get next page
	 * @return a Page of Di18ns for the specified updatedDate
	 */
	CursorPage<Di18n, java.lang.String> queryPageByUpdatedDate(java.util.Date updatedDate,
            int pageSize, String cursorString);


		  
	// ----------------------- one-to-one finders -------------------------

	// ----------------------- many-to-one finders -------------------------
	
	// ----------------------- many-to-many finders -------------------------

	// ----------------------- uniqueFields finders -------------------------
	
	
	// ----------------------- populate / persist method -------------------------

	/**
	 * Persist an entity given all attributes
	 */
	Di18n persist(Object parentKey,  	
		java.lang.String langCode, 
		java.lang.String trans);	

}
